import numpy as np
import pandas as pd
import glob
import matplotlib.pyplot as plt
import matplotlib as mpl
from scipy.constants import mu_0
Msat = 800e3
#lex = 5.47e-9
Aex = 11e-12
#Aex = lex**2*mu_0*Msat**2/2
H_u = 0
H_s = 0
J_bl = 0
J_bq = 0
d = 2
C_j = (J_bl - 2*J_bq)/(Msat*d)
d = 2e-3
s = 1e-3
k_ = np.linspace(0.1,100,1000)
gamma = 1.760859644e11
lex = np.sqrt(2*Aex/(mu_0*Msat**2))

def zeta(k,d,s):
    return np.sinh(k*d/2)/(k*d/2) *np.exp(-np.abs(k)*d/2)

def g(k,d,s):
    return mu_0 *Msat *(zeta(k,d,s))**2 * np.exp(-np.abs(k)*s) *k*d/2

def p(k,d,s):
    return mu_0 *H_u  + mu_0*Msat*k**2 *lex**2 + mu_0*Msat*(1-zeta(k,d,s))

def q(k,d,s):
    return mu_0 *H_u - mu_0*H_s + mu_0*Msat*k**2 *lex**2 + mu_0*Msat*zeta(k,d,s)

def f1(k,d,s, J_bl=0):
    C_j = (J_bl - 2*J_bq)/(Msat*d)
    return gamma/(2*np.pi)*(g(k,d,s) + np.sqrt((p(k,d,s) - g(np.abs(k),d,s))*(q(k,d,s)-g(np.abs(k),d,s)-2*C_j)))

def f2(k,d,s, J_bl=0):
    C_j = (J_bl - 2*J_bq)/(Msat*d)
    print(C_j)
    return gamma/(2*np.pi)*(-g(k,d,s) + np.sqrt((p(k,d,s) + g(np.abs(k),d,s))*(q(k,d,s)+g(np.abs(k),d,s)-2*C_j)))


s_min = 2
s_max = 10
nr_spacing = 31
el_spacing = (s_max-s_min)/(nr_spacing-1)
s_ = np.arange(s_min,s_max + el_spacing,el_spacing)
d = 2
max_freq = []
delta_f_max_theo = []
fig, (ax1, ax2) = plt.subplots(1,2)
norm = mpl.colors.Normalize(vmin=2, vmax=20)

for i, s in enumerate(s_):
    cmap = mpl.cm.get_cmap('viridis')
    c = cmap(norm(s))
    alpha_factor = 1 if i % 4 == 0 else 0.2
    df = pd.read_csv(f"spacing_{s}nm/dispersion.csv")
    k_ = df["k (rad/m)"]
    freqs = df["f0 (GHz)"]
    delta_f = freqs.values - np.flip(freqs.values)
    max_freq.append(max(delta_f))
    max_k = k_[np.argmax(delta_f)]

    s *= 1e-9
    delta_f_th = f1(k_,d*1e-9,s)*1e-9-f1(-k_,d*1e-9,s)*1e-9
    #ax1.plot(k_*1e-6, delta_f)
    if i % 4 == 0:
        ax1.plot(k_*1e-6, delta_f_th, lw=3, c=c,alpha=.5*alpha_factor,ls="--")
        ax1.plot(max_k*1e-6,max(delta_f),lw=0,marker="o",markerfacecolor="none",markeredgecolor=c)
    ax1.plot(k_*1e-6, delta_f,alpha=alpha_factor,c=c)

    delta_f_max_theo.append(max(delta_f_th))

ax2.plot(s_, max_freq,lw=3,alpha=0.5,ls="--")
ax2.plot(s_, max_freq)
ax1.set_xlim([0,400])
ax1.set_ylim([0,6])
ax2.set_xlim([2,10])
ax2.set_ylim([0,6])
plt.show()
print("success")
